// CLOCK options
// CLK is generated by GPR
`define PRC_WATCH
`define USE_DMY_CLOCK

`define RAM_DRIVEN_CLK2X
`define ROM_DRIVEN_CLK2X

// CORE definition
//`define SUPPORT_LDST32  // +13 - +24 slices
`define SUPPORT_LDD	  // reduced ver (31 >= disp >= 0)  (notyet at all)

// use tri-state bus (emulation for SP3)
//`define OUTPUT_MUX_TRI

// don't use OE_RAM / OE_RAM
`define OUTPUT_MUX_NONE

// mux by or IOR sub-modules
`define OUTPUT_MUX_OR

// S2 parameter
`define FLAGS_MUX_OR

// GPR build options
`define GPR_INITCLR

// tuning option
`define NO_STALL_IDX
`define GPR_WB_TUNE

// for checking performance
//`define GPR_2X_ONLY

`define RTAVR_PORT_ESCALATION		// RTAVR is sub-module
`define IOR_PORT_ESCALATION		// IOR is sub-module

// top layer configuration
`define RTAVR_INCLUDE_IOR
`define RTAVR_INCLUDE_RAM
`define RTAVR_INCLUDE_ROM
`define RTAVR_INCLUDE_INTCONT

// IOR configuration
//`define IOR_HAVE_PORTA
`define IOR_HAVE_PORTB
`define IOR_HAVE_PORTC
`define IOR_HAVE_SREG_SP
//`define FIXED_SPH	0	// fixed SPH (-19 slices)
`define IOR_SPHBITS	2	// SPH bits 1-8 (-15 slices)
`define IOR_HAVE_INT0
//`define IOR_HAVE_INT1
//`define IOR_HAVE_RAMWIN
//`define IOR_HAVE_RAMWIN_HA	// hi-addr
//`define IOR_HAVE_TIM0
//`define IOR_HAVE_TIM0_OC0A
//`define IOR_HAVE_TIM0_OC0B
//`define IOR_HAVE_SPI
//`define IOR_HAVE_USART
// `define IOR_HAVE_TWI 	// notyet

`ifdef IOR_HAVE_RAMWIN
`define RAM_HAVE_PORTA
`endif

// ROM configuration

// use rom_data.dat (using $readmemh) default
`define ROM_INCLUDE_DAT
// use rom_data.v
//`define ROM_INCLUDE_V

//`define ROM_SIZE 1024
`define ROM_SIZE 2048
//`define ROM_SIZE 4096

// S1 options : (obsolute)
//`define OUTPUT_WB_ADDR
//`define CHECK_CONFLICT

// PORT configuration
//`define PORT_HAVE_PIN_WRITE
//`define PORT_WATCH		// (debug option)

// TIM0 configuration
//`define TIM0_EXPORT_PS	// using when other timer is used
`define FIXED_CS0	3	// Prescaler 1: 1/1 2: 1/8 3: 1/64
				//           4: 1/256 5: 1/1024
				//   stop : write 0 set: write other val
`define FIXED_WGM0	0	//
`define FIXED_COM0B	0	//
`define FIXED_COM0A	0	//
//`define FIXED_OCR0B	127	//
`define FIXED_OCR0A	128	//


// USART configuration
//`define USART_LOCAL_LB
`define FIXED_MPCM	0	// 0: 
`define FIXED_U2X	1	// prescaler option
`define FIXED_UMSEL	0	// 0: async 1:sync 3: spi master
`define FIXED_UPM	0	// parity 0: none 2: even 3: odd
`define FIXED_USBS	0	// stop-bit 0: st1 1: st2
`define FIXED_UCSZ	3	// 2: 7bit 3: 8bit 7: 9bit
`define FIXED_UDORD	0	// 0: LSB first 1: MSB first (only in spi)
`define FIXED_UCPHA	0	// clock phase 0: IN-SFT 1: SFT-IN (only in spi)
`define FIXED_UCPOL	0	// clock polarity 0: normal 1: reversed
//`define FIXED_UBRR	107	// boud parameter (12bit)
`define UBRR_BITS	8	// boud parameter (2 - 16)


// SPI configuration
//`define SPI_HAVE_WCOL
//`define SPI_HAVE_PSV_SS
`define FIXED_MSTR	1 	// 1: Master 0: Slave
`define FIXED_DORD	0 	// 0: MSB first 1: LSB first
`define FIXED_CPOL	0	// 0: Noraml SCK , 1: Reversed SCK
`define FIXED_CPHA	0	// 0:IN_ SFT order , 1: SFT_IN order
//`define FIXED_SPR	0	// 0: 1/2 CLK , 1: 1/4 CLK 2: 1/8 CLK
				// 3: 1/16 CLK , 4: 1/32 CLK 5,6: 1/64 CLK
				// 7: 1/128 CLK 

// 
`define INT0_vect_num            1
`define INT1_vect_num            2
//`define INT2_vect_num            3
//`define INT3_vect_num            4
`define TIM0_COMPA_vect_num     11
`define TIM0_COMPB_vect_num     12
`define TIM0_OVF_vect_num       13
`define USART_TX_vect_num       14
`define USART_UDRE_vect_num     15
`define TWI_SLAVE_vect_num      16
`define SPI_vect_num            17
`define USART_RX_vect_num       18

`define	 PORTA_ADDR  6'h00   // PINA 0x00 , DDRA, PORTA
`define	 PORTB_ADDR  6'h04   // PINB 0x04 , DDRB, PORTB
`define	 PORTC_ADDR  6'h1b   // PINC 0x1b , DDRC, PORTC
`define	 RAMWIN_ADDR 6'h1f   // RAMDR 0x1f , RAMAR 0x20
`define	 TIM0_ADDR   6'h15   // OCR0B 0x15 - TCCR0A 0x19
`define	 SREG_ADDR   6'h3f   // SREG 0x3f , SPH,SPL,CCP,RSRFR,MCUCR 0x3a
`define	 MCUCR_ADDR  6'h3a   // MCUCR 0x3a
`define	 GIFR_ADDR   6'h0b   // GIFR 0x0b , GIMSK 0x0c
`define	 TIFR_ADDR   6'h25   // TIFR 0x25 , TIMSK 0x26  
`define	 USART_ADDR  6'h0e   // USART : (0x0e - 0x14 ADC space)
`define	 SPI_ADDR   6'h2e    // SPI : SPDR 0x2e, SPSR, SPCR
`define	 TWI_ADDR   6'h28    // TWI : TWSD 0x28, TWSAM,TWSA, TWSSRA

`define	 INT0_BIT  18     // PC2
`define	 INT1_BIT  10     // PB2
`define	 OC0A_BIT  16     // PC0
`define	 OC0B_BIT   5     // PA5
`define	 SS_BIT    16     // PC0
`define	 SCK_BIT   17     // PC1
`define	 MOSI_BIT  20     // PC4
`define	 MISO_BIT  18     // PC2
`define	 RX_BIT    21     // PC5
`define	 TX_BIT    22     // PC6
`define	 XCK_BIT   23     // PC7
`define	 SDA_BIT   20     // PC4
`define	 SCL_BIT   17     // PC1
